<template>
    <div class="list-view">
        <page-title>
            <!-- <el-button
                @click="addRow"
                type="primary"
                icon="el-icon-plus"
                :disabled="fetchingData || downloading"
                class="filter-item"
            >
                新增
            </el-button>
            <el-button
                @click="download"
                icon="el-icon-upload2"
                :loading="downloading"
                :disabled="fetchingData"
                class="filter-item"
            >
                导出
            </el-button> -->
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
            <el-input class="filter-item" placeholder="搜索企业ID" v-model="userId" @keyup.enter.native="getData"></el-input>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
            v-loading="fetchingData"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="userId" label="企业管理者ID" width="100"></el-table-column>
            <el-table-column prop="minter" label="企业名称" width="120"></el-table-column>
            <el-table-column prop="name" label="名称"> </el-table-column>
            <el-table-column prop="createdAt" label="创建时间" width="150">
                <template slot="header" slot-scope="{ column }">
                    <sortable-header :column="column" :current-sort="sort" @changeSort="changeSort"> </sortable-header>
                </template>
            </el-table-column>
            <el-table-column prop="pic" label="作品内容" width="90" align="center">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px"
                        :src="row.pic[0].thumb || row.pic[0].url"
                        fit="cover"
                        :preview-src-list="row.pic.map(i => i.thumb || i.url)"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="total" label="发行数量" width="105" align="center">
                <template slot="header" slot-scope="{ column }">
                    <sortable-header :column="column" :current-sort="sort" @changeSort="changeSort"> </sortable-header>
                </template>
            </el-table-column>
            <el-table-column prop="price" label="价格"> </el-table-column>
            <el-table-column prop="status" label="审核状态" :formatter="statusFormatter" width="120" align="center">
            </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" width="120">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>

        <el-dialog :visible.sync="showReasonDialog" width="600px" title="拒绝理由">
            <el-form ref="denyForm" :model="denyForm" label-position="right" label-width="60px" :rules="denyRules">
                <el-form-item prop="reason" label="理由">
                    <el-input type="textarea" :autosize="{ minRows: 3 }" v-model="denyForm.reason"></el-input>
                </el-form-item>
            </el-form>
            <div slot="footer">
                <el-button @click="showReasonDialog = false">取消</el-button>
                <el-button type="primary" @click="saveReason">保存</el-button>
            </div>
        </el-dialog>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/companyCollection/all',
            downloading: false,
            statusOptions: [
                { label: '审核中', value: 'PENDING' },
                { label: '通过', value: 'SUCCESS' },
                { label: '失败', value: 'FAIL' }
            ],
            typeOptions: [
                { label: '默认', value: 'DEFAULT' },
                { label: '盲盒', value: 'BLIND_BOX' },
                { label: '拍卖', value: 'AUCTION' }
            ],
            denyForm: {},
            denyRules: {
                reason: [{ required: true, message: '请填写理由' }]
            },
            showReasonDialog: false,
            userId: ''
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        typeFormatter(row, column, cellValue, index) {
            let selectedOption = this.typeOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {
            return { search: this.search, query: { del: false, status: 'FAIL', userId: this.userId } };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/companyCollectionEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/companyCollectionShow',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/companyCollection/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/companyCollection/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        pass(row) {
            this.$confirm('确定通过？')
                .then(res => {
                    return this.$http.post('/companyCollection/pass', { id: row.id });
                })
                .then(res => {
                    this.$message.success('成功');
                    this.getData();
                })
                .catch(e => {});
        },
        deny(row) {
            this.showReasonDialog = true;
            this.denyForm.id = row.id;
        },
        saveReason() {
            this.$confirm('确定拒绝？')
                .then(res => {
                    return this.$http.post('/companyCollection/deny', { id: this.denyForm.id, reason: this.denyForm.reason });
                })
                .then(res => {
                    this.$message.success('成功');
                    this.showReasonDialog = false;
                    this.getData();
                })
                .catch(e => {});
        }
    }
};
</script>
<style lang="less" scoped>
</style>
